'Version vom 09.05.2009

Set WshShell = Wscript.CreateObject("WScript.Shell")
Set FSO      = CreateObject("Scripting.FileSystemObject")
Set net      = Wscript.createObject("Wscript.network")
Set db1      = CreateObject("ADODB.Connection")
Dim Aktiv, Log, Logpfad


'**************************************************************
'Einstellungen
'**************************************************************
'Logs / Debug
Log=1                            'Bei 1 werden Logfiles erstellt. Bei 0 nicht
Logpfad="c:\"                    'Pfad fr Logfile

'Fr LightsOut
Aktion=1                         'Aktionen fr Lightsout 0=nichts, 1=Standby, 2=Ruhezustand, 3=Herunterfahren

'Fr Taskplaner
PLUser=      "Administrator"
PLPW=        "xxx"

'Fr Mediaportal
CheckMP=     1                  'Zur Nutzung ohne Mediaportal =0 ; Mit MP = 1
SQLServer=  "Server\SQLEXPRESS"
SQLUser=    "sa"
SQLPW=      "mediaportal"
DWH=        "MpTvDb"
Zeitdiff =  3                   'Minuten vor Aufnahmenbeginn aufwachen

'**************************************************************
'Start (diverse Einstellungen)
'**************************************************************
Aktiv=0        'Das muss so. Sobald ein Kriterium zum wachbleiben erfllt ist, erhht sich der Wert.
               'Ist der Wert am Ende des Scripts noch immer 0, dann wird Lightsout fr Standby konfiguriert.
SingleStart    'Doppelausfhrung verhindern
setup          'Regestryeintrag anlegen
Taskliste      'Es wird unter c:\taskliste.txt eine Liste aller aktiven Programme erstellt.
               'Hieraus knnen die Suchbgriffe fr die Programmprfung bernommen werden.

'**************************************************************
'Beginn Hauptprogramm
'**************************************************************
Do while 1=1 ' Beginn Endlosschleige
logdatei "--- Start ---"
Aktiv=0

'**************************************************************
'Prfen ob Programme online
'**************************************************************
'z.B.
'WSHCheckTask ("Notepad.exe")
WSHCheckTask ("flatster.exe")
WSHCheckTask ("iexplore.exe")

'**************************************************************
'Prfen ob Rechner online
'**************************************************************
'z.B.
'WSHonline ("Buerorechner")
'WSHonline ("192.168.1.8")

'**************************************************************
'Befehl ausfhren und Ergebnis durchsuchen
'**************************************************************
'z.B.
'cmdline "dir C:\","testdatei.txt"


'**************************************************************
'Mediaportal
'**************************************************************
if CheckMP=1 then
      'Task zum Aufwachen anlegen, wenn noch nicht vorhanden
      if not fso.fileexists("C:\WINDOWS\Tasks\MP_Aufnahmen.job") then
      intReturn = WshShell.Run("SCHTASKS /Create /ru "&lcase(net.computerName)&"\"&PLUser&" /RP "&chr(34)&PLPW&chr(34)&" /SC tglich /TN MP_Aufnahmen /TR C:\WINDOWS\system32\tasklist.exe /ST 00:00:00" , 1, true)
      msgbox "Der Task wurde neu angelegt. Bitte setzte bei dem automatischen Task 'MP_Aufnahmen' hndisch die Option 'Computer zum Ausfhren des Tasks reaktivieren'.",0,"Achtung"
      end if

      'Datenbankabfrage
      db1.Open("Driver={SQL Server};SERVER="&SQLServer&";Database="&DWH&";User ID="&SQLUser&";Password="&SQLPW)
set rs1=db1.execute("SELECT min(Starttime) as start from " & _
                          "(     select dateadd(mi,(preRecordInterval+"&Zeitdiff&")*-1,Starttime) as starttime, dateadd(mi,PostRecordInterval+"&Zeitdiff&",Endtime) as endtime " & _
                          "      from schedule " & _
                          "      where scheduleType=0 " & _
                          "    union " & _
                          "      select dateadd(mi,datepart(mi,starttime)-(preRecordInterval) -"&Zeitdiff&" ,dateadd(hh,datepart(hh,starttime),heute)) as startime, " & _
                          "             dateadd(mi,datepart(mi,endtime)+(PostRecordInterval)+"&Zeitdiff&" ,dateadd(hh,datepart(hh,endtime),heute)) as endtime " & _
                          "      from schedule " & _
                          "               inner join (SELECT DATEADD(dd, 0, DATEDIFF(dd, 0, GETDATE())) as heute,DATEADD(dd, -1, DATEDIFF(dd, 0, GETDATE())) as gestern, DATEADD(dd, +1, DATEDIFF(dd, 0, GETDATE())) as morgen  ) as UA " & _
                          "               on 1=1 " & _
                          "      where scheduleType in(1,3,4) or (scheduleType=2 and datepart(dw,heute)=datepart(dw,starttime)) or (scheduleType=6 and datepart(dw,heute) in (1,2,3,4,5)) or (scheduleType=5 and datepart(dw,heute) in (6,7)) " & _
                          "    union " & _
                          "      select dateadd(mi,datepart(mi,starttime)-(preRecordInterval) -"&Zeitdiff&" ,dateadd(hh,datepart(hh,starttime),morgen)) as startime, " & _
                          "             dateadd(mi,datepart(mi,endtime)+(PostRecordInterval)+"&Zeitdiff&" ,dateadd(hh,datepart(hh,endtime),morgen)) as endtime " & _
                          "      from schedule " & _
                          "               inner join (SELECT DATEADD(dd, 0, DATEDIFF(dd, 0, GETDATE())) as heute,DATEADD(dd, -1, DATEDIFF(dd, 0, GETDATE())) as gestern, DATEADD(dd, +1, DATEDIFF(dd, 0, GETDATE())) as morgen  ) as UA " & _
                          "               on 1=1 " & _
                          "      where scheduleType in(1,3,4) or (scheduleType=2 and datepart(dw,morgen)=datepart(dw,starttime)) or (scheduleType=6 and datepart(dw,morgen) in (1,2,3,4,5)) or (scheduleType=5 and datepart(dw,morgen) in (6,7)) " & _
                          "    union " & _
                          "      select dateadd(mi,datepart(mi,starttime)-(preRecordInterval) -"&Zeitdiff&" ,dateadd(hh,datepart(hh,starttime),gestern)) as startime, " & _
                          "             dateadd(mi,datepart(mi,endtime)+(PostRecordInterval)+"&Zeitdiff&" ,dateadd(hh,datepart(hh,endtime),gestern)) as endtime " & _
                          "      from schedule " & _
                          "               inner join (SELECT DATEADD(dd, 0, DATEDIFF(dd, 0, GETDATE())) as heute,DATEADD(dd, -1, DATEDIFF(dd, 0, GETDATE())) as gestern, DATEADD(dd, +1, DATEDIFF(dd, 0, GETDATE())) as morgen  ) as UA " & _
                          "               on 1=1 " & _
                          "      where scheduleType in(1,3,4) or (scheduleType=2 and datepart(dw,gestern)=datepart(dw,starttime)) or (scheduleType=6 and datepart(dw,gestern) in (1,2,3,4,5)) or (scheduleType=5 and datepart(dw,gestern) in (6,7)) " & _
                          ") as ua " & _
                          "where endTime>current_timestamp")

      if isdate(rs1("Start")) then 'Wenn Aufnahmen programmiert sind oder aktuelle eine luft...
         if rs1("Start")<now() then
           'Es luft gerade eine Aufnahme
           aktiv=aktiv+1
              if "A"&WshShell.RegRead("HKCU\SOFTWARE\AxoNet Software GmbH\LightsOut\MP_Aufnahme")<>"A"&"01.01.2020" then
                 Logdatei "Set Taskplaner:  01.01.2020"
                 intReturn = WshShell.Run("SCHTASKS /change /ru "&lcase(net.computerName)&"\"&PLUser&" /RP "&chr(34)&PLPW&chr(34)&" /TN MP_Aufnahmen /ST 00:00 /SD 01/01/2020" , 1, true)
                 WshShell.RegWrite "HKCU\SOFTWARE\AxoNet Software GmbH\LightsOut\MP_Aufnahme","01.01.2020","REG_EXPAND_SZ"
              else
                 Logdatei "Taskplaner = 01.01.2020"
              end if
         else
           'Es ist eine Aufnahme geplant, ggf Starttask anlegen
            'wenn Task nicht schon angelegt wurde, anlegen
              if "A"&WshShell.RegRead("HKCU\SOFTWARE\AxoNet Software GmbH\LightsOut\MP_Aufnahme")<>"A"&rs1("Start") then
                 Logdatei "Set Taskplaner: "&rs1("Start")
                 intReturn = WshShell.Run("SCHTASKS /change /ru "&lcase(net.computerName)&"\"&PLUser&" /RP "&chr(34)&PLPW&chr(34)&" /TN MP_Aufnahmen /ST "&right(rs1("Start"),8)&" /SD "&replace(left(rs1("Start"),10),".","/") , 1, true)
                 WshShell.RegWrite "HKCU\SOFTWARE\AxoNet Software GmbH\LightsOut\MP_Aufnahme",rs1("Start"),"REG_EXPAND_SZ"
              else
                 Logdatei "Taskplaner = "&rs1("Start")
              end if
         end if
      end if
      db1.close
end if

'**************************************************************
'Aktion nach X Minuten in LightsOut konfigurieren
'**************************************************************
if Aktiv=0 then
WshShell.RegWrite "HKLM\SOFTWARE\AxoNet Software GmbH\LightsOut\Action",Aktion,"REG_DWORD"
Logdatei "Set LightsOut = "&Aktion
else
WshShell.RegWrite "HKLM\SOFTWARE\AxoNet Software GmbH\LightsOut\Action","0","REG_DWORD"
Logdatei "Set LightsOut = 0 (keine Aktion)"
end if

wscript.sleep 5*60000 '5 Minuten / 1000 = 1 Sekunde
loop 'Wieder zum Schleifenanfang





Sub Setup
'**************************************************************
'Prfen ob Registry schon besteht
'**************************************************************
on error resume next
  WshShell.RegRead("HKCU\SOFTWARE\AxoNet Software GmbH\LightsOut\MP_Aufnahme")
  if err.number<>0 then
   WshShell.RegWrite "HKCU\SOFTWARE\AxoNet Software GmbH\LightsOut\MP_Aufnahme","01.01.2020","REG_EXPAND_SZ"
  end if
on error goto 0
end sub


'**************************************************************
Sub SingleStart 'sobald gleiches Script bereits luft,
                'wird das aktuelle Script beendet
'**************************************************************
  Anz = 0
  Const wbemFlagReturnImmediately = &h10
  Const wbemFlagForwardOnly = &h20
  Dim objWMIService : Set objWMIService = GetObject("winmgmts:\\.\root\CIMV2")
  Dim colItems      : Set colItems = objWMIService.ExecQuery("SELECT * FROM Win32_Process", "WQL", wbemFlagReturnImmediately + wbemFlagForwardOnly)
  Dim objItem
  For Each objItem In colItems
    If InStr( LCase( objItem.CommandLine), LCase( WScript.ScriptFullName ) ) > 0 Then
       Anz = Anz + 1
    End If
  Next
  if Anz>1 then
  wscript.quit
  end if

End Sub

'********************************************************************************************
Sub WSHCheckTask (textx) 'Sobald Task aktiv, wird Variable "Aktiv" und eins erhht

  Set objWMIService = GetObject("winmgmts:\\.\root\CIMV2")
  wbemFlagReturnImmediately = &h10:wbemFlagForwardOnly = &h20
  Set colItems = objWMIService.ExecQuery("SELECT * FROM Win32_Process", "WQL", wbemFlagReturnImmediately + wbemFlagForwardOnly)
  For Each objItem In colItems
    if instr(lcase(objItem.CommandLine),lcase(textx))>0 then
    Aktiv=Aktiv+1
    Logdatei "Anwend aktiv:   "&textx
    end if
  Next
end Sub

'********************************************************************************************
Sub WSHonline (textx) 'Sobald Rechner aktiv, wird Variable "Aktiv" und eins erhht
'********************************************************************************************
Set cPingResults = GetObject("winmgmts:{impersonationLevel=impersonate}//./root/cimv2"). ExecQuery("SELECT * FROM Win32_PingStatus WHERE Address = '" + textx + "'")
For Each oPingResult In cPingResults
	If oPingResult.StatusCode = 0 Then
	Aktiv=Aktiv+1
        Logdatei "IP aktiv:   "&textx
	End If
Next
end Sub

'********************************************************************************************
Sub Taskliste
'********************************************************************************************
  Set FileOut = fso.createTextFile(logpfad&"\taskliste.txt",True)
    Set objWMIService = GetObject("winmgmts:\\.\root\CIMV2")
    wbemFlagReturnImmediately = &h10:wbemFlagForwardOnly = &h20
    Set colItems = objWMIService.ExecQuery("SELECT * FROM Win32_Process", "WQL", wbemFlagReturnImmediately + wbemFlagForwardOnly)
      For Each objItem In colItems
        FileOut.WriteLine objItem.CommandLine&" "
      Next
  FileOut.Close
  Set FileOut = Nothing
End Sub

'-------------------------------------------------------------------------------
Sub LogDatei (LogTxt) '01.01.2007
'-------------------------------------------------------------------------------
if log=1 then
  on error resume next
  Set FileOut = fso.OpenTextFile( logpfad&"\WHS_Standby.log" , 8, true)
      FileOut.WriteLine Now()&"  "&LogTxt
      FileOut.Close
  Set FileOut = Nothing
  on error goto 0
end if
End Sub

'-------------------------------------------------------------------------------
sub cmdline(textx,texty)'
'-------------------------------------------------------------------------------
intReturn = WshShell.Run("cmd.exe /u /c "&textx&" >C:\tmp.txt" , 0, true)
Set FileIn = FSO.getFile("C:\tmp.txt")
set FileIn2 = FileIn.openAsTextStream(1,-1) '-1 = Unicode
set FileIn3 = FileIn.openAsTextStream(1,0) '0 = Ascii
  if instr(FileIn2.readall&FileIn3.readall,texty)>0 then
  Aktiv=Aktiv+1
  end if
fileIn2.close
fileIn3.close
fso.deletefile("c:\tmp.txt")
end sub